/*
 * NEXCOM PowerDigiS CMS
 * 
 * Copyright © 2011 
 */

/*** Global Varible ***/
var g_username = "";
var g_level = 0;
var langid = 0;
var g_json;
var g_LangLoaded = 0;
var g_submenu = "";
var g_Interval = 0;
var gaiSelected =  [];
var g_version = '';
var g_CMSIP=null;
var g_DATETIME=new Array(); 
/*** Group Setting in Player_Management.js ***/
var g_selectedPlayer = "";
var g_selectedIP = "";
var g_selectedHost = "";
var g_CMSHost = "";
var g_PlayersCheckedArray = new Array(); 
var g_groupDisplayResult = '';
var g_groupTimeResult = '';
var g_groupLocalResult = '';
var g_groupNetworkResult = '';
var g_groupOfflineResult = '';
var preselectID='';
/*** Main Table ***/
var oMainTable;
var g_selectedGroup;

/*** Console Debug ***/
var g_debug = 1; 

/*** Dispatch ***/
var g_DispatchActive = false;

/*** Alert Notification ***/
var PlayerEmail = new Array();
var CMSEmail = new Array();

var Email = new Object();
var SMS = new Object();
var Log = new Object();
var Alert = new Array();

/*** Hidden Function ***/
var g_ver = 1.3;
var chckeInitMainTable=true;

var GroupOnlineIp=false;

var g_Status = new Array();
var g_Setting = new Array();
var g_Control = new Array();
var g_selectedId = "";

function Authentication() {
	
	/* Every page should has this segment of javascript */
    $.post('login.php', {'account':'', 'passwd': ''},
    function(data) {
        //data = $.trim(data);
        if (data.charAt(0) == '{') {
            var json = $.parseJSON(data);
            
            if (json.result != "AuthOK") window.location.href = "index.html";
        
            g_username = json.username;
            g_level = json.level;
			langid = json.language;
			g_DATETIME=json.datetime;
		
			if (g_LangLoaded == 0) InitLoadLanguage();
			
		} else {
			
            window.location.href = "index.html";
        
        }
    });
    
}

function InitLoadLanguage() {
	
	$.getJSON("language.php", {'lang': langid}, 
		function(json) {
			g_json = json;
			
			
			InitLocalization(json);
			
			InitMainTable(json);
			
			g_LangLoaded = 1;

			SpecialEvents(); //For Testing...

	});	
}

function InitLocalization(json){

/*** Main Menu & Sub Menu ***/
	
	//Management Menu
		$("#Main_Player").html(json.Main_Player);		//Management
		$("#Main_Designer").html(json.Main_Designer);	//Designer
		$("#Main_Publish").html(json.Main_Publish);		//Publish
		$("#Main_Setting").html(json.Main_Setting);		//Administration
		
	//Management Menu | Sub Menu	
		$("#Mgmt_Overview").html(json.Mgmt_Overview);	//Status
		$("#Mgmt_Setting").html(json.Mgmt_Setting);		//Setting
		$("#Mgmt_Control").html(json.Mgmt_Control);		//Control
		$("#Mgmt_Message").html(json.Mgmt_Message);		//Message
		$("#Mgmt_Alert").html(json.Mgmt_Alert);			//Alert
		$('#Mgmt_Log').html(json.Mgmt_Log);				//Log
	
	//Publish | Sub Menu
		$("#CMS_Schedule").html(json.CMS_Schedule);		//Schedule

	//Administration | Sub Menu
		$("#CMS_Health").html(json.CMS_Health);		//Status
		$("#CMS_Setting").html(json.CMS_Setting);	//Setting
		$("#CMS_Control").html(json.CMS_Control);	//Control
		$("#CMS_Alert").html(json.Mgmt_Alert);		//Alert
		$("#CMS_Log").html(json.CMS_Log);			//Log


/*** Sub Content Menu ***/
	
	//Management | Status | Sub Content Menu
		$("#OverView_BasicInfo").html(json.OverView_BasicInfo);	//BasicInfor
		$("#OverView_Service").html(json.Health_Service); 		//Health
		$("#OverView_Hardware").html(json.OverView_Hardware);	//Hardware
		$("#OverView_Network").html(json.OverView_Network);		//Network Traffic
		$("#OverView_Display").html(json.OverView_Display);		//Display

	//Management | Setting | Sub Content Menu
		$("#Setting_Network").html(json.Setting_Network);		//Network
		$("#Setting_Time").html(json.Setting_Time);				//Time
		//$("#Setting_License").html(json.Setting_License);
		$("#Setting_Display").html(json.Setting_Display);		//Display
		$("#Setting_FWUpdate").html(json.Setting_FWUpdate);		//Firmware Update
		//$("#Setting_Output").html(json.Setting_Output);
	
	//Management | Control | SubMenu Menu	
		$("#Control_Status").html(json.Control_Status);			//Actions
		$('#Control_RS232').html(json.RS232_Command_Btn);		//RS232 Command
		$('#Control_Schedule').html(json.Schedule_Control);		//Schedule Control
		//$("#Control_Output").html(json.Control_Output);
	
	//Management | Message | Sub Content Menu	
		$("#Message_Emergency").html(json.Message_Emergency);
		$("#Message_Notification").html(json.Message_Notification);
	
	//Management | Alert | 	Sub Content Menu
		$("#Alert_Notification").html(json.Alert_Notification);	//Notification
		$("#Alert_Setting").html(json.Alert_Setting);			//Notification Events
	
	//Management | Log | Sub Content Menu
		$("#Report_Generator").html(json.Report_Generator);	//Filter

	//Publish | Schedule SubMenu Menu 	
		$("#Publish_Properties").html(json.Publish_Properties);			//Propoerties
		$("#Publish_Dispatch").html(json.Publish_Dispatch);				//Dispatch
		$('#Publish_ExportImport').html(json.Schedule_Export_Import);	//Export/Import
		
	//Administration | Status | Sub Content Menu
		//$("#Health_CPU").html(json.Health_CPU);
		$("#Health_Service").html(json.Health_Service);		//Service
		//$("#Health_Process").html(json.Health_Process);
		$("#Health_System").html(json.Health_System);		//Hardware
		//$("#Health_Memory").html(json.Health_Memory);
		
	//Administration | Setting | SubMenu Menu
		$("#CMSConf_Time").html(json.CMSConf_Time);			//Time
		$("#CMSConf_Network").html(json.CMSConf_Network);	//Network
		$("#CMSConf_ACL").html(json.CMSConf_ACL);			//Access Control
		$("#CMSConf_License").html(json.CMSConf_License);	//License	
		$('#CMSConf_Profile').html(json.Control_Profile);	//Profile
		//$("#CMSConf_Language").html(json.CMSConf_Language);
		
	//Administration | Control | Sub Contetnt Menu
		$("#CMS_Control_Actions").html(json.Control_Actions);								
		
	//Administration | Alert | SubMenu Menu
		$("#Report_Setting").html(json.Report_Setting);		//Notification
		$("#CMSConf_Alert").html(json.Alert_Setting);
		$("#CMSConf_ExtServer").html(json.Alert_ExtServer);
	
	
/*** Main Content ***/

//Players Table	
		$("#Column_Player").html(json.Column_Group + "/" + json.Column_Player);
		$("#Column_Group").html(json.Column_Group);
		$("#Column_Presentation").html(json.Column_Presentation);
		$("#Column_Status").html(json.Column_Status);
		$("#Column_ProcStatus").html(json.Column_Status);
		$("#Column_LastUpdate").html(json.Column_LastUpdate);
		$("#Column_Storage").html(json.Column_Storage + " (MB)");
		$("#Column_Model").html(json.Column_Model);
		$("#Column_Mac").html(json.Column_Mac);
		$("#Column_IP").html(json.Column_IP);
		$("#Column_Location").html(json.Column_Location);
		$("#Column_Version").html(json.Column_Version);
		$("#Column_ScreenMode").html(json.Column_ScreenMode);
		$("#Column_PID").html(json.Column_PID);
		$("#Column_Process").html(json.Column_Process);
		$("#Column_User").html(json.Column_User);
		$("#Column_CPU").html("%"+json.Column_CPU);
		$("#Column_RealMem").html(json.Column_RealMem);
		$("#Column_VirtualMem").html(json.Column_VirtualMem);

//Navigator Bar
		$("#Tool_ExpandAll").attr('title', json.Tool_ExpandAll);
		$("#Tool_AddGroup").attr('title', json.Tool_AddGroup);
		$("#Tool_AddPlayer").attr('title', json.Tool_AddPlayer);
		$("#Tool_ViewFilter").attr('title', json.Tool_ViewFilter);
		$("#Tool_VideoWall").attr('title', json.Tool_VideoWall);
		$("#Tool_DeletePlayer").attr('title', json.Tool_DeletePlayer);
		$("#Tool_group_setting").attr('title', json.CMS_GtoupSetting);
		//$("#Tool_RefFilter").attr('title', json.Tool_DeletePlayer);

/*** Sub Content ***/
	
	//Management | Status | Basic Info 
		$("#BasicInfo_PlayerInfo").html(json.BasicInfo_PlayerInfo);
		$("#BasicInfo_Name").html(json.BasicInfo_Name + " :");
		$("#BasicInfo_Version").html(json.BasicInfo_Version + " :");
		$("#BasicInfo_IP").html(json.BasicInfo_IP + " :");
		$("#BasicInfo_Time").html(json.BasicInfo_Time + " :");
		$("#BasicInfo_Mode").html(json.BasicInfo_Mode + " :");
		$("#BasicInfo_Location").html(json.Column_Presentation + " :");
		$('#snapshotSubmit').html(json.Button_GetSnapshot);
		
	//Players Status 
		$("#Bar_Total").html(json.Bar_Total);
		$("#Bar_Playing").html(json.Bar_Playing);
		$("#Bar_Updating").html(json.Bar_Updating);
		$("#Bar_Sleep").html(json.Bar_Sleep);
		$("#Bar_Offline").html(json.Bar_Offline);
		
/*** Title Bar - UserName & Log Out ***/
		$("#Login_Username").html(g_username + ",");	
		$("#Main_Logout").html(g_json.Main_Logout + "<img src='./images/lock.gif' />");
		
	//Alert
		$("#Alert_Email").html(g_json.Alert_Email);
		$("#Alert_Email_Subject").html(g_json.Alert_Email_Subject + ' :');
		$("#Alert_Email_Reciver").html(g_json.Alert_Email_Reciver + ' :');
		$("#Alert_Email_Sendto").html(g_json.Alert_Email_Sendto + ' :');
		$("#Alert_Email_Remove").html(g_json.Alert_Email_Remove);
	

}

function GoBackFromDesigner(){
	
	var suburl = window.location.href.split('#');
	
	if (suburl.length > 1) {
		switch(suburl[1]) {
		
		case "schedule":
		
			$("#Main_Publish").trigger('click');
		
			//Fixed reload bug
			window.location.hash = '';
		
			break;
		
		case "log":
		
			$("#Main_Setting").trigger('click');
		
		    //Fixed reload bug
			window.location.hash = '';
		
			break;
		
		default:
					
			$(".smenu").first().click();
		
			break;
		}
		
	} else {
		$(".smenu").first().click();
	}	
	
}

function SpecialEvents(){
	
	
	if (g_level > 2) {	//it's not administrator
		$('input').attr('disabled', true);
		$('select').attr('disabled', true);
		$('textarea').attr('disabled', true);		
	}
	
	InitMainMenuButtons();
	InitMainMenuEvents(); 
	InitNavBarButtons(); 

	//initalEmailSmsLogFields(); //Initial Email SMS Log fields
	PlayerAlertNotification();
	
	InitWindowEvents();
	
	//buttomMenuactive();
	
	$('#initWindow').hide();
	$('#container').css('visibility','visible');
	
	GoBackFromDesigner(); //Must after InitMainMenuButtons();
	
	PublishDispatchFailedRecordsStartup(); 
}

function InitWindowEvents(){
	
	$(window).resize(function(){ 
		$("#Dialog_addGroup").dialog("option","position","center"); 
		$("#Dialog_AddPlayer").dialog("option","position","center"); 
		$("#dialogGroup_setting").dialog("option","position","center"); 
		//$("#dialogEnterPrsnName").dialog("option","position",['center',60]);
		$('#Dialog_AddEdgeServer').dialog("option","position","center");
		
		var failedRecordsDialogOffset = $('#content').offset();
		$('#failedRecords').css({'top':failedRecordsDialogOffset.top+162,'left':failedRecordsDialogOffset.left+320});
		 
		$(document).find('.toast-position-middle-center').css({'top':failedRecordsDialogOffset.top+380,'left':failedRecordsDialogOffset.left+440});
	});
	
	//For need reload functions
	$(window).focus(function(){
		//Emergency & Notification Status
		if (($('#Message_Emergency').attr('class') == 'menu menu_h' || $('#Message_Notification').attr('class') == 'menu menu_h') && $('#stable input[name=players]:checked').length == 1) {
			updateMessageStatus(g_selectedIP);
		}
	});	
	
	//Know Issue: CANNOT work correctly on Google Chrome
	window.onbeforeunload = function(){
		if (g_DispatchActive){
			if (!confirm("Some processing are not finish yet!! Are you sure to close the browser?")) return false;
		}
		
	};
	
}

function InitMainMenuButtons(){
	
	//Logout
	$("#Main_Logout").click(function () {
		$.post('login.php', {'logout':'true'},
			function(data) {
				window.location.href = "index.html";
		});
		return false;
	});
	
	//Management Button
	$("#Main_Player").click(function() {
		InitMainTable(g_json);
	});
		
	//Designer Button
	$("#Main_Designer").click(function() {
		if (g_level == 3) return false;
		
		(g_DispatchActive == false)? window.location.href = "Designer/Designer.html" : window.open('Designer/Designer.html');
		
		return false;
	});
	
	//Publish Button	
	$("#Main_Publish").click(function() {
		if (g_level == 3) return false;
	});	
	
	//Administration Button
	$("#Main_Setting").click(function() {
		if (g_level == 2) return false;
	});
	
}

function InitMainMenuEvents(){ 
	
	$('.sul').show();
	$("#mainMenu").accordion({
		autoHeight: true,
		changestart: function(event, ui) {
			
			mainMenuActive($(ui.newHeader[0]).find(".menu")); 			
			$(ui.newContent[0]).find(".smenu:first").click();

		}
	});	
	
	$("#mainMenu h3").each(function() {
		$(this).find("span:first").remove();
	});
	
	$("#subMenu a").click(function() {		
		buttomMenuClick($(this).attr('id'));
		
		$("#subMenu a").each(function() {
			$(this).removeClass('menu_h');
		});
		
		$(this).addClass('menu_h');		
		return false;
	});
	
	$(".smenu").click(function(){
		//Discard - change in html file
		//if (g_level == 2 && $(this).attr('id') != "Mgmt_Overview" && $(this).attr('id') != "CMS_Schedule") return false; 
		
		subMenuActive($(this));

		return false;
	});
	
}

function InitNavBarButtons() { 
	
// Expand_All button
	$('#Tool_ExpandAll').click(function () {
		
		var expandStatus = false;
		
		$('#stable tbody tr[class="group"]').each(function() { //Partial to expand
			if ($(this).find('td.group span').html() == '►') {
				$(this).find('.checkgroup').click();
				expandStatus = true;
			}
		});
	
		if (!expandStatus) {	//Collapse to expand
			$('#stable tbody tr[class="group"]').each(function() {
				$(this).find('span[class="checkgroup"]').click();
			});
		}
		
		return false;
	});

// Add Groups Button
	//$("#Dialog_addGroup").dialog({ autoOpen: false }); 
	$('#Tool_AddGroup').click(function () {
		
		GroupAddGroupDialogDefine(); // in main_OverView.js
		
		fnDialog_addGroup(); // in main_OverView.js
		
		dialogOpenCloseRest("#Dialog_addGroup"); // in main_OverView.js
		
		return false;
	});	

// Add Players Button
	$('#Tool_AddPlayer').click(function () {
		$("#Dialog_PlayerName").val("");
		$("#Dialog_IPAddress").val("");
		fnDialog_AddPlayer(); // in main_OverView.js
		
		
		return false;
	});

// Add Edge Server Button
	$('#Tool_AddEdgeServer').click(function() {
		
		EdgeServerAddDialogDefine(); // in main_OverView.js
		
		dialogOpenCloseRest("#Dialog_AddEdgeServer"); // in main_OverView.js
		
		return false;
	});
	
// Video Wall Button
	$("#Dialog_VideoWall").dialog({ autoOpen: false }); 
	/*$('#Tool_VideoWall').click(function() {
		return false; //ForTagVersion
		
		fnDialog_VideoWall();
		
		$("#Dialog_VideoWall").dialog({
			height: 365,
			width: 435,
			autoOpen: false,
			resizable: false,
			title: "Add Player",
			buttons: [
				{
					text: "Cancel",
					click: function() { $(this).dialog("close"); }
				},
				{
					text: "Save",
					click: function() { 
						//TODO: Video Wall implementation
						
						$(this).dialog("close"); 
					}				
				}
			]
		});
		
		dialogOpenCloseRest("#Dialog_VideoWall");
	
		return false;
	}); 
	*/
	
// Delete Players Button
	$('#Tool_DeletePlayer').click(function() {					
		
		if (validatePlayersSelected("count") != true) return false; 
		
		if (!confirm(g_json.Tool_DeletePlayer+" ?")) return false;
		
		$('#stable input[name="players"]:checked').each(function() {			
			$(this).attr('checked',false);
			$.post("main_PlayerInfo.php", {'opt':'delPlayer', 
									       'mac':$(this).val(),
										   'IP':$(this).attr('ip')}, 
			function(data) {
				InitMainTable(g_json);
			});
		});		
		$("#BasicInfo_Name_Val").html("");
		$("#BasicInfo_Location_Val").html("");
		$("#BasicInfo_Version_Val").html("");
		$("#BasicInfo_IP_Val").html("");
		clearInterval(g_Interval);
		$("#BasicInfo_Time_Val").html("");
		$("#BasicInfo_Mode_Val").html("");	
		g_selectedIP="";
		$("#Mgmt_Overview").click()
		return false;
	});

// Group Setting Button
	$("#Tool_group_setting").click(function() {
		
		if(validatePlayersSelected("count") != true) { return false; }
		//if(validatePlayersSelected("offline") != true) { return false; }
		if(validatePlayersSelected("group") != true) { return false; }
		$('#stable input[name="group"]:checked').each(function() {			
		$(this).parent().parent().nextUntil('tr[class="group"]').find('input[name="players"]:checked').each(function(){	
				if($(this).parent().parent().next().next().text()!= g_json.Bar_Offline){
					GroupOnlineIp =  $(this).attr('ip');					
				}					
			});	
		});
		
		if(!GroupOnlineIp){	$().toastmessage('showWarningToast',g_json.MSG_0093) ; return false;} //Please select online player(s) to continue.	 }
		GroupSettingDialogDefineEvents();
		
		GroupSettingsDialogDefine(); 
		
		GroupSettingLocalization();
			
		GroupSettingGetStatus();	
		
		$("#GROUP_msdimg").children().remove();
		
		$("#dialogGroup_setting").dialog('open');
		
		return false;
	});

// View Filter Button in ColVis.js

// Refresh Table button
	$("#Tool_RefFilter").click(function () {
		
		/*
		var gTrs = $('#stable tbody tr');
		gTrs.each(function() {
			$(this).remove();
		});
		*/
		if(chckeInitMainTable){
			chckeInitMainTable=false;		
			InitMainTable(g_json);
			
		}
		return false;
	});
	
//CSS
	$('#Tool_RefFilter').css({'cursor':'pointer'});
	$('#Tool_ViewFilter').css({'cursor':'pointer'});
	$('button').find('[class="ColVis_Button TableTools_Button"]').css({'cursor':'pointer'});	
	
	
}

/*** MainTable ***/

function InitMainTable(json) {	
	
	$("#stable_filter").remove(); //Search Bar	
	//Initialization
	g_PlayersCheckedArray = "";
	
	$("#Tool_RefFilter").removeAttr('disabled', true);
		
	oMainTable = $('#stable').dataTable({
						"bPaginate":true,
						"sPaginationType": "full_numbers",
						"bLengthChange": false,
						"iDisplayStart":0,
						"iDisplayLength": 10,
						//"bJQueryUI": true,
						"bInfo": true, //TEST, orgin: false
						"bAutoWidth": false,
						"bStateSave": true,	//If true, the iDisplayLength value would be saved on the client side, to change it, remember to clear history of browser.
						"iCookieDuration": 60*60*24*7, // 7 days
						"sScrollX": "100%",
						"sScrollXInner": "100%",
						//"sScrollY": "280px",
						"bScrollInfinite": false, //true
						"bScrollCollapse": false, 
						"bProcessing": true, 
						"bServerSide": true,
						"sAjaxSource": "dataTable_PlayerList.php",
						"bDestroy": true,
						"fnServerData": fnDataTablesPipeline,		//Show Players Status Bar
						//"sPaginationType": "full_numbers",
						"fnInitComplete": fnInitComplete,
						"fnRowCallback": fnRowCallback,
						"fnDrawCallback": fnDrawCallback,
						"aoColumnDefs": [
							{ "bVisible": false, "aTargets": [ 0 ] },	//Group
							{ "bVisible": false, "aTargets": [ 7 ] },	//Mac
							{ "bVisible": false, "aTargets": [ 8 ] },	//IP
							{ "bVisible": false, "aTargets": [ 9 ] },	//Location
							{ "bVisible": false, "aTargets": [ 10 ] },	//Version
							{ "bVisible": false, "aTargets": [ 11 ] }	//ScreenMode
						],		
						"sDom": 'C<"clear">lfrtip',	//ColVis intergrate with ColReorder + R prefix
													//"sDom": 'Rlfrtip'
						
						"aaSortingFixed": [[ 0, 'asc' ]],
						"aaSorting": [[ 1, 'asc' ]],
		
						//Language Translate
						"oLanguage": {
							"sSearch": json.Main_Search + " :",
							"sEmptyTable": json.Table_NoData,
							"sInfo": json.Table_Info,
							"sInfoEmpty": json.Table_Empty,
							"sInfoFiltered": json.Table_Filter,
							"sZeroRecords": json.Table_NoMatch,
							"sProcessing": json.Table_Processing,
							"oPaginate": {
								"sFirst": json.Table_First,
								"sLast": json.Table_Last,
								"sNext": json.Table_Next,
								"sPrevious": json.Table_Previous
							}
						}
				});	
	
	//Table Search.
	//$("<input type='image' src='./images/search_submit.gif' class='submit'/>").appendTo("#stable_filter");
	
	
	$("#stable_filter").appendTo($("#viewOption")).css({'float':'right','position':'relative'});
	$("#viewOption").find('input').css({'width':'170px'});
	

}

function fnDataTablesPipeline ( sSource, aoData, fnCallback ) {

$.ajax({
            "dataType": 'json',
	    "cache": false,
            "url": sSource,
            "data": aoData,
            "success": function(json){
               $("#Bar_Total_Val").html(json.iTotalRecords);
		$("#Bar_Playing_Val").html(json.aaStatus[0]);
		$("#Bar_Sleep_Val").html(json.aaStatus[1]);
		$("#Bar_Offline_Val").html(json.aaStatus[2]);
		$("#Bar_Updating_Val").html(json.aaStatus[3]);
		fnCallback(json);
		setTimeout(function(){chckeInitMainTable=true;},2000);
		//chckeInitMainTable=true;
            },
    })

/*	
	$.getJSON( sSource, aoData, function (json) { 
		
		$("#Bar_Total_Val").html(json.iTotalRecords);
		$("#Bar_Playing_Val").html(json.aaStatus[0]);
		$("#Bar_Sleep_Val").html(json.aaStatus[1]);
		$("#Bar_Offline_Val").html(json.aaStatus[2]);
		$("#Bar_Updating_Val").html(json.aaStatus[3]);
		
		fnCallback(json);
		setTimeout(function(){chckeInitMainTable=true;},2000);
	
	});
*/	
}

function fnRowCallback ( nRow, aData, iDisplayIndex,iDesplayIndexFull) {
	if($('td:eq(2)', nRow).html()!=aData[3]){
		return nRow;
	}
	switch(aData[3]) {	
		case "0":
			$('td:eq(2)', nRow).html("<img src='images/b_green.png'/>" + g_json.Bar_Playing);
			break;
		case "1":
			//$('td:eq(2)', nRow).html("<img src='images/b_red.png'/>" + g_json.Bar_Sleep);
			$('td:eq(2)', nRow).html("<img src='images/b_red.png'/>Stop");
			break;
		case "2":
			$('td:eq(2)', nRow).html("<img src='images/b_black.png'/>" + g_json.Bar_Offline);
			break;
		case "3":
			$('td:eq(2)', nRow).html("<img src='images/b_orange.png'/>" + g_json.Bar_Updating);
			break;
		case "4":
			//$('td:eq(2)', nRow).html("<img src='images/b_red.png'/>Pause");
			$('td:eq(2)', nRow).html("<img src='images/b_red.png'/>" + g_json.Bar_Sleep);
			break;
	}
	
	if ($("#Column_ScreenMode").html() != null && $("#Column_ScreenMode").html() != "") {
		switch(aData[11]) {
			case "0":
				$('td:last', nRow).html("Clone");
			break;
			case "1":
				$('td:last', nRow).html("Combine");
			break;
			case "2":
				$('td:last', nRow).html("Independent");
			break;
			default:
				$('td:last', nRow).html("undefined");
			break;
		}
	}
	
	if( $("#NetworkSetting_Name_Val").val()!=""){ 
		if (g_selectedIP == aData[8]) {
			aData[1] = $("#NetworkSetting_Name_Val").val();
		}
	}
	//aData[7] is Mac Address (PlayerID)
	
	$('td:eq(0)', nRow).html( "<p class='list_playername' title='" + aData[1]+" ' >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" 
		+ "<input type='checkbox' id='"+aData[12]+"' name='players' groupname='"+aData[0]+"' value='" + aData[7] + "' ip='" + aData[8] + "' host='" + aData[1] + "' mac='"+aData[12]+"' modelname='"+aData[6]+"'> " + aData[1]+"</p>");
	var id = aData[12];
	$.post('main_PlayerSetting.php', {'opt':'GetXMLInfo', 'modelname':aData[6],'IP':aData[8]},function(data){
		
		var json = $.parseJSON(data);
		$("#"+id).attr("resetdefault",json.Management.Setting.FirmwareUpdate);
		$("#"+id).attr("wakeupsystem",json.Management.Setting.WakeOnLAN);
		$("#"+id).attr("rs232command",json.Management.Control.RS232DeviceControl);
		$("#"+id).attr("message",json.Management.Message);
		$("#"+id).attr("alert",json.Management.Alert);
		$("#"+id).attr("log",json.Log.status);
	});
	
	// Change Prsn Name (Testing ...)
	var html="";
	if (aData[2] != null && aData[2] != undefined && aData[2] != "") {
		if (aData[2].charAt(0) == '[') {
			var tmpPrsn = $.parseJSON(aData[2]);
			
			for (var i = 0; i < 1; i++){
				html+= tmpPrsn[i].name ;
			}
		}else{
			html=aData[2];
		}
		$('td:eq(1)', nRow).html(html);
	
	}
	
	return nRow;
}

function fnDrawCallback ( oSettings ) {
	
	//if (oSettings.aoData[iDisplayIndex] == undefined) return false;

	if ( oSettings.aiDisplay.length == 0 )	{
		return;
	}
	
	
	var gTrs = $('#stable tbody tr[class="group"]');
	gTrs.each(function() {
		$(this).remove();
		//oMainTable.fnDeleteRow($(this));
	});

	//Count all Trs.
	var nTrs = $('#stable tbody tr');
	var iColspan = nTrs[0].getElementsByTagName('td').length;
	var sLastGroup = "";
	var iGroupMember = 0;
	
	//if (oSettings.aoData[iDisplayIndex] != undefined){
		for ( var i=0 ; i<nTrs.length ; i++ )
		{
			var iDisplayIndex = i; /*oSettings._iDisplayStart */
			
			var sGroup = oSettings.aoData[ oSettings.aiDisplay[iDisplayIndex] ]._aData[0];
			if ( sGroup != sLastGroup )
			{
				var nGroup = document.createElement( 'tr' );
				nGroup.className = "group";
				var nCell = document.createElement( 'td' );
				nCell.colSpan = iColspan;
				nCell.className = "group";
				/* TODO: use Group ID here */
				
				nCell.innerHTML = "&nbsp;<span class='checkgroup'>▼</span>&nbsp;<input type='checkbox' name='group' value='" + sGroup + "'> " + sGroup
					+ " (<span id='" + sGroup.replace(/ /g, '') + "'></span>)";	//group member
				
				nGroup.appendChild( nCell );
				nTrs[i].parentNode.insertBefore( nGroup, nTrs[i] );

				$(nGroup).find("td span.checkgroup").toggle(function() {	//Collapse toggle

					var str = $(this).parent('td').html();
					var arr = str.split(';');
					$(this).html("►");				
					
					var strParentParent = $(this).parent().parent();				
					$(strParentParent).nextUntil("tr[class='group']").toggle();
				
				}, function () {	//Expend toggle
			
					var str = $(this).parent('td').html();
					var arr = str.split(';');				
					
					$(this).html("▼");
					
					var strParentParent = $(this).parent().parent();				
					$(strParentParent).nextUntil("tr[class='group']").toggle();
				
				});
		
				sLastGroup = sGroup;
				iGroupMember = 1;
				$('#' + sLastGroup.replace(/ /g, '')).html(iGroupMember);
				
				
				$(nGroup).find("td input[name='group']").unbind('click');
				$(nGroup).find("td input[name='group']").click(function() {
					
					var ThisGroupName = $(this).val();
					var strParentParent = $(this).parent().parent().parent();

					if ($(this).is(':checked')) {			
						$(strParentParent).find('td input[name="players"][groupname="'+ThisGroupName+'"]').attr('checked',true).trigger('change');
						$(strParentParent).find('td input[name="players"][groupname="'+ThisGroupName+'"]').parent().parent().parent().addClass('row_selected');
					} else {					
						$(strParentParent).find('td input[name="players"][groupname="'+ThisGroupName+'"]').attr('checked',false).trigger('change');
						$(strParentParent).find('td input[name="players"][groupname="'+ThisGroupName+'"]').parent().parent().parent().removeClass('row_selected');
					}

				});

			} else {
				if (sLastGroup != "")
					$('#' + sLastGroup.replace(/ /g, '')).html(++iGroupMember);
			}

		}	
	//}
	
		
}

function fnInitComplete() {

	//Adjust table width
	var oSettings = oMainTable.fnSettings();
	
	var columnlength = $('#stable thead th').length;
	
	var extra = columnlength - 6;
	if (extra > 0){ //Adjust when hidden columns showed
		var xInner = 100 + (extra * 16);
		oSettings.oScroll.sXInner = xInner + "%";
		
		oMainTable.fnDraw(); 
	}
	
	//Clear Row_selected
	$(oMainTable.fnSettings().aoData).each(function (){
		$(this.nTr).removeClass('row_selected');
	});
	
	/* ROW Click event handler */
	MainTableRowClickEvent();
	
}




function setScheduleTime(tag, value)
{
	//alert('tag: ' + tag + ' value: ' + value);
	if(value == 'null')
	{
		$('#' + tag + '_hour').val(value);
		$('#' + tag + '_minute').prop('disabled', true);
		$('#' + tag + '_secend').prop('disabled', true);
		return;
	}
	var valueArray = value.split(':');
	
	$('#' + tag + '_hour').val(parseInt(valueArray[0]));
	$('#' + tag + '_minute').val(parseInt(valueArray[1]));
	$('#' + tag + '_secend').val(parseInt(valueArray[2]));
}

function setSelectChange(tag)
{
	var selectedCountry = $('#' + tag + "_hour").children("option:selected").val();
	
	if(selectedCountry == 'null')
	{		
		$('#' + tag + "_minute").prop('disabled', true);
		$('#' + tag + "_secend").prop('disabled', true);	
		$('#' + tag + "_minute").val(0);
		$('#' + tag + "_secend").val(0);
		
	}else
	{	
		$('#' + tag + "_minute").prop('disabled', false);
		$('#' + tag + "_secend").prop('disabled', false);
	}
}

function getSetTimeValue(tag)
{
	if($("#"+ tag + "_hour").children("option:selected").val() != 'null')
	{		
		return $("#"+ tag + "_hour").children("option:selected").val() + ":" + $("#"+ tag + "_minute").children("option:selected").val() + ":"+
		$("#" + tag + "_secend").children("option:selected").val();

	}
	return 'null';
}


function getTimeValue(g_selectedIP)
{
	
	$.post("setgetData.php",{'opt':'getTime' ,'IP':g_selectedIP  },
			function(data){
			var jsonData = JSON.parse(data);			
			
			setScheduleTime('root',  jsonData['scheduleReboot']);
			setScheduleTime('shutdown',  jsonData['scheduleOFF']);
			setScheduleTime('wake',  jsonData['scheduleON']);
			setSelectChange('shutdown');
			setSelectChange('wake');
			setSelectChange('shutdown');
			
			
		
	});
}

function MainTableRowClickEvent(){



	$('#root_hour').unbind('change');
	$('#root_hour').change(function() 
	{
		setSelectChange('root');	
	});	
	$('#shutdown_hour').unbind('change');
	$('#shutdown_hour').change(function() 
	{
		setSelectChange('shutdown');			
	});	
	$('#wake_hour').unbind('change');
	$('#wake_hour').change(function() 
	{
		setSelectChange('wake');	
		
	});	
	$('#save_button').unbind('click');
	$('#save_button').click(function() 
	{
		var scheduleON= getSetTimeValue('wake');
		var scheduleOFF= getSetTimeValue('shutdown');
		var scheduleReboot= getSetTimeValue('root');
	
		$.post("setgetData.php",{'opt':'setTime' ,'IP':g_selectedIP,'scheduleON':scheduleON,'scheduleOFF':scheduleOFF,
			'scheduleReboot':scheduleReboot},
		function(data)
		{
			var jsonData = JSON.parse(data);
		
			if(jsonData['result'])
			{
				alert("成功");

			}else
			{
				alert("失敗");
			}
	
		});
		
	});
	
	$("#stable tbody").unbind('click');
	$("#stable tbody").click(function(event) {
		
		
		if ($(event.target.parentNode).hasClass('group')) return;	 //Skip Group row
	
		if ($(event.target).is('input')){	//Checkbox
			
			var node = $(event.target.parentNode).parent().parent();
		
			if ($(event.target).is(':checked')){
				
				g_selectedPlayer = $(event.target).val();
				g_selectedIP = $(event.target).attr('ip');
				g_selectedHost = $(event.target).attr('host');
				g_selectedGroup = $(event.target).attr('groupname');
				g_selectedId = $(event.target).attr('mac');
				var modelname = $(event.target).attr('modelname');
				
				//alert('preselectID '  + preselectID);
				if(preselectID != '' && g_selectedId != preselectID)
				{
					$("#" + preselectID).attr("checked", false);
				}
				preselectID = g_selectedId;
				getTimeValue(g_selectedIP);
				//alert('preselectID: ' + preselectID + " g_selectedId: " + g_selectedId);
				
				$(node).addClass('row_selected');
				
			} else {
				
				
				g_selectedPlayer = '';
				g_selectedIP = '';
				g_selectedHost = '';
				g_selectedGroup = '';
				g_selectedId = '';
				
			
				//preselectID ='';
				if ($('#stable input[name=players]:checked').length != 0){
					
					if(preselectID != '' && g_selectedId != preselectID)
					{
						$("#" + preselectID).attr("checked", false);
					}
					var selectedFirst = $('#stable input[name=players]:checked').first();
					g_selectedPlayer = selectedFirst.val();
					g_selectedIP = selectedFirst.attr('ip');
					g_selectedHost = selectedFirst.attr('host');
					g_selectedGroup = selectedFirst.attr('groupname');
					g_selectedId = selectedFirst.attr('mac');
					
					
					preselectID = g_selectedId;
					getTimeValue(g_selectedIP);
					var modelname = selectedFirst.attr('modelname');
				}
				
				$(node).removeClass('row_selected');
				
			}
			
			$.post('main_PlayerSetting.php', {'opt':'GetXMLInfo', 'modelname':modelname,'IP':g_selectedIP},function(data){
					var json = $.parseJSON(data);
					
				g_Status = json.Management.Status;
				g_Setting = json.Management.Setting;
				g_Control = json.Management.Control;
				
				Message = json.Management.Message;
				Alert = json.Management.Alert;
				Log = json.Log;
				
				if (g_Setting.AVIN == "0" && g_Setting.GPS == "0") {
					$("#Setting_GPS").hide();
				} else {
					$("#Setting_GPS").show();
					if (g_Setting.GPS == "0") {
						$("#GPS_title").hide();
						$("#Port_title").hide();
						$("#BaudRate_title").hide();
						$("#GPS_Port").hide();
						$("#GPS_BaudRate").hide();
						$("#Setting_GPS").html("AVIN");
					} else {
						$("#GPS_title").show();
						$("#Port_title").show();
						$("#BaudRate_title").show();
						$("#GPS_Port").show();
						$("#GPS_BaudRate").show();
						$("#Setting_GPS").html("AVIN & GPS");
					}
				}
				
				if (Log.status == "0") {
					$("#Mgmt_Log").hide();
					$("#Mgmt_Log").parent("div").addClass("smenu");
				} else {
					$("#Mgmt_Log").show();
					$("#Mgmt_Log").parent("div").removeClass("smenu");
				}
					
			}); 

			MainTableGroupChecked();
			buttomMenuactive(); //reload current page
			
		} else {	//non-checkbox
			 
			var node = ($(event.target).is('img'))||($(event.target).is('p'))? $(event.target.parentNode).parent() : $(event.target.parentNode);					
			var nodeCheckBox = $(node).find('input[type="checkbox"]');
			
				
			if (nodeCheckBox.is(':checked')){
				
				g_selectedPlayer = '';
				g_selectedIP = '';
				g_selectedHost = '';
				g_selectedGroup = '';
				g_selectedId = '';
				nodeCheckBox.attr('checked',false);	//Uncheck
								
				if ($('#stable input[name=players]:checked').length != 0){
					if(preselectID != '' && g_selectedId != preselectID)
					{
						$("#" + preselectID).attr("checked", false);
					}

					var selectedFirst = $('#stable input[name=players]:checked').first();
						
					g_selectedPlayer = selectedFirst.val();
					g_selectedIP = selectedFirst.attr('ip');
					g_selectedHost = selectedFirst.attr('host');
					g_selectedGroup = selectedFirst.attr('groupname');
					g_selectedId = selectedFirst.attr('mac');
					preselectID = g_selectedId;	
					getTimeValue(g_selectedIP);
				} 
				
				$(node).removeClass('row_selected');
				
			
				
			} else {
				if(preselectID != '')
				{
					$("#" + preselectID).attr("checked", false);
				}
				g_selectedPlayer = nodeCheckBox.val();
				g_selectedIP = nodeCheckBox.attr('ip');
				g_selectedHost = nodeCheckBox.attr('host');
				g_selectedGroup = nodeCheckBox.attr('groupname');
				g_selectedId = nodeCheckBox.attr('mac');
				preselectID = g_selectedId;
				nodeCheckBox.attr('checked',true);	//Check
				preselectID = g_selectedId;	
					getTimeValue(g_selectedIP);
				$(node).addClass('row_selected');
				
				
			}

			MainTableGroupChecked();
			buttomMenuactive(); //reload current page
			
		}	
		
		// Select first row - Discard
		/*
		//$('#stable tbody tr[class="odd"]').first().click();
		if (g_selectedPlayer == "") {
			var first = $('#stable tbody tr[class="odd"]').first();
			g_selectedPlayer = $(first).find("input").val();
			g_selectedIP = $(first).find("input").attr('ip');
			g_selectedHost = $(first).find("input").attr('host');
			buttomMenuactive();
		}	

		CheckedPlayerHasChecked(g_PlayersCheckedArray);	
		*/
		
	});
	
}

function fnViewFilter(column, visible) {	
	//Remove all rows.
	var gTrs = $('#stable tbody tr');
	gTrs.each(function() {
		$(this).remove();
	});
	
	oMainTable.fnClearTable();
	oMainTable.fnSetColumnVis(column, visible);
}

function fnGetSelected( oTableLocal ) {		

	/* Get the rows which are currently selected */
	
	var aReturn = new Array();
	var aTrs = oTableLocal.fnGetNodes();
	
	for ( var i=0 ; i<aTrs.length ; i++ )
	{
		if ( $(aTrs[i]).hasClass('row_selected') )
		{
			aReturn.push( aTrs[i] );
		}
	}
	return aReturn;
}

function MainTableGroupChecked(){	

	var mainTableTr = $('#stable tbody tr');
		
	mainTableTr.find('[class="group"]').each(function(){
		
		var tmpGroup = $(this).parent();
		var checkAll = true;
		var tmpTotal = 1;
		var checkNone = 1;

		tmpGroup.nextUntil('tr[class="group"]').find('input[type="checkbox"][name="players"]').each(function(){

			if (!$(this).is(':checked')) {
				checkAll = false;
				checkNone++;
			}
			
			tmpTotal++

		});

		if (checkAll){
			tmpGroup.find('input[type="checkbox"][name="group"]').attr('checked',true).trigger('change');
		} else {
			if (checkNone == tmpTotal) tmpGroup.find('input[type="checkbox"][name="group"]').attr('checked',false).trigger('change');
		}
	});

}

/*** Validation  ***/

/* Network */

function ValidationNetworkAddress(address){
	
	var tmpAddress = address.split('.');
	
	if (tmpAddress.length != 4)	return false;
	
	for (var i = 0; i < tmpAddress.length; i++) {
		if (isNaN(tmpAddress[i]) || parseInt(tmpAddress[i],10) > 255 || parseInt(tmpAddress[i],10) < 0) {
			return false;
		}
	}
}

function ValidationNetworkIP(ip){ 
	
	ValidationNetworkAddress(ip);
	
	//Range Validation	
	//TEST
	
}

function ValidationNetworkSubnet(subnet){
	
	ValidationNetworkAddress(subnet);
	
	var tmpSubnet = subnet.split('.');
	
	pattern = new Array(254,252,248,240,224,192,128,0);
	
	for (var i; i < tmpSubnet.length; i++){
		for (var j; j < pattern.length; j++){
			if (tmpSubnet[i] != pattern[j]) return false;
		}
	}
}

/** checking **/

function IPValidCheck(address) {
	var ip = address.split('.');
	
	if (ip.length != 4)	return false;
	
	for (var i=0; i< ip.length; i++) {
		if (isNaN(ip[i]) || parseInt(ip[i]) > 255 || parseInt(ip[i]) < 0) {
			return false;
		}
	}
	
	return true;
}

function AlphaNumericCheck(checkString) {
	var regExp = /^[A-Za-z0-9]$/;
	
	if(checkString != null && checkString != "")
	{
		for(var i = 0; i < checkString.length; i++)
		{ 
			if (!checkString.charAt(i).match(regExp))
			{
				return false;
			}
		}
	}
	else
	{
	  return false;
	}
	return true;
}

function AlphabetsCheck(checkString) {
	var regExp = /^[A-Za-z]$/;
	
	if(checkString != null && checkString != "")
	{
		for(var i = 0; i < checkString.length; i++)
		{ 
			if (!checkString.charAt(i).match(regExp))
			{
				return false;
			}
		}
	}
	else
	{
	  return false;
	}
	return true;
}

function emailValidCheck(email) {

	var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	if (!filter.test(email)) {
		$().toastmessage('showErrorToast',g_json.MSG_0017); //: Please provide a valid email address
		return false;
	}

	return true;
}

function PhoneValidCheck(number) {
    var error = "";
    var stripped = number.replace(/[\(\)\.\-\ ]/g, '');    

   if (number == "") {
        $().toastmessage('showWarningToast',g_json.MSG_0018);	//Please enter a phone number
        return false;
    } else if (isNaN(parseInt(stripped))) {
        $().toastmessage('showErrorToast',g_json.MSG_0019);	//The phone number contains illegal characters
        return false;
    } else if (!(stripped.length == 10)) {
        $().toastmessage('showErrorToast',g_json.MSG_0020);	//The phone number is the wrong length
        return false;
    }
    
    return true;
}

function FNS_CheckSpecialSymbols(textname){
	var namecheck = /(\S*)\\(\S*)/;
	if ( namecheck.test(textname)) {
		$().toastmessage('showErrorToast',g_json.Designer_namecheck); //File name can not contain the following characters: \ ' "
		return false;									
	}

	var namecheck = /(\S*)'(\S*)/;
	if ( namecheck.test(textname)) {
		$().toastmessage('showErrorToast',g_json.Designer_namecheck);
		return false;									
	}
	
	var namecheck = /(\S*)"(\S*)/;
	if ( namecheck.test(textname)) {
		$().toastmessage('showErrorToast',g_json.Designer_namecheck);
		return false;									
	}
	
	return true;			
}

function CheckedPlayerHasChecked(PlayersCheckedArray) {
	$('#stable input[name="players"]').each(function() {				
		for(var i=0 ; i<PlayersCheckedArray.length ; i++)
		{
			if ( $(this).val() == PlayersCheckedArray[i]["mac"] ) $(this).attr("checked",true);				
		}
	});			
}

/*** Menu Events ***/

function mainMenuActive(menu) {	

	$(".menu_h").each(function() {
		$(this).removeClass("menu_h");
	});
	
	$(menu).addClass("menu_h");
}

function buttomMenuactive() {	
	switch(g_submenu) {
		case "#1":
			ContentSwitch('MainTable');
			bottomMenuSwitch("subOverview");
			
			fnBasicInfo(); //in Overview.js
			break;
		case "#2":
			if(validatePlayersSelected("count") != true) { break; }
			if(validatePlayersSelected("offline") != true) { break; }
			bottomMenuSwitch("subSetting");
			fnNetworkSetting();	
			break;
		case "#3":
			if(validatePlayersSelected("count") != true) { break; }
			//if(validatePlayersSelected("offline") != true) { break; }
			bottomMenuSwitch("subControl");
			fnPlayerAction();
			break;
		case "#4":
			if(validatePlayersSelected("count") != true) { break; }
			if(validatePlayersSelected("offline") != true) { break; }
			bottomMenuSwitch("subMessage");
			fnEmergencyMsg();
			break;
		case "#5":
			if(validatePlayersSelected("count") != true) { break; }
			if(validatePlayersSelected("offline") != true) { break; }
			bottomMenuSwitch("subAlert");
			(isHide())? fnAlertNotice() : fnAlertSetting();	//Version 1.3.0
			break;
		case "#a":
			ContentSwitch('showSchedule');
			bottomMenuSwitch("subPublish");
			fnCMSSchedule();
			break;
		case "#b":
			if(validatePlayersSelected("count") != true) { break; }
			if(validatePlayersSelected("offline") != true) { break; }
			if ($("#"+g_selectedId).attr('log') == "0") {
				$("#Player_LogFilter").hide();
				$("#plg5").hide();
				$("#plg4").hide();
				$("#plogc3").hide();
				$("#szPlayerLog_Log_Filter").hide();
				$("#Mgmt_Log").hide();
				$("#Mgmt_Log").parent("div").addClass("smenu");
				break; 
			} else {
				$("#Player_LogFilter").show();
				$("#plg5").show();
				$("#plg4").show();
				$("#plogc3").show();
				$("#szPlayerLog_Log_Filter").show();
				$("#Mgmt_Log").show();
				$("#Mgmt_Log").parent("div").removeClass("smenu");
			}
			bottomMenuSwitch("subPlayerLog");
			fnPlayerLogFilter();
			break;			
		case "#c":
			ContentSwitch("CMSInfo");
			bottomMenuSwitch("subHealth");
			fnCMSService();
			break;		
		case "#d":
			bottomMenuSwitch("subCMSConf");
			fnCMSTimeSetting();
		
			
			break;	
		case "#e":
			bottomMenuSwitch("subReport");
			fnLogGenerator();
		break;
		case "#f":
			bottomMenuSwitch("subCMSControl");
			fnCMSControl();
		break;
		case "#g":
			bottomMenuSwitch("subCMSAlert");
			//fnCMSAlertSetting();
			//fnLogSetting(); //Change to Notification
			(isHide())? CMSShowAlertSetting() : fnCMSAlertSetting(); //Version 1.3.0
			break;
	}
}

function subMenuActive(smenu) {
	
	$(".smenu_h").each(function() {		//smenu_h
		var str = $(this).html();
		var arr = str.split(';');
		$(this).html(arr[1]);
		$(this).removeClass("smenu_h");
		$(this).addClass("smenu");
	});
	
	var myname = $(smenu).html();
	if (myname != "") {
		$(smenu).html("►&nbsp;" + myname);
		$(smenu).addClass("smenu_h");
	}
	
	g_submenu = $(smenu).attr('href');
	buttomMenuactive();
}

function bottomMenuSwitch(menu) {
	$("#subMenu ul").hide();
	$("#" + menu).show();
	$("#" + menu + " a").removeClass('menu_h');
	$("#" + menu + " a").first().addClass('menu_h');
}

function subContentSwitch(content) {
	$("#szContent div[type='subcontent']").hide();
	$("#" + content).show();
}

function ContentSwitch(content) {
	$("#showZone div[type='content']").hide();
	$("#" + content).show();
}

function buttomMenuClick(bmenu) {	
	switch (bmenu) {
	case "OverView_BasicInfo":
		
		fnBasicInfo();
	break;
		case "OverView_Service":
		OverviewService();
		break;
	case "OverView_Hardware":
		fnHardwareInfo();
	break;
	case "OverView_Network":
		fnNetworkAnalysis();
	break;
	case "OverView_Display":
		fnDisplayInfo();
	break;
	case "Setting_Network":
		fnNetworkSetting();
	break;
	case "Setting_Time":
		fnTimeZoneSetting();
	break;
	case "Setting_FWUpdate":
		fnPlayerFWUpdate();
	break;
	case "Setting_Display":
		fnDisplaySetting();
	break;
	case "Setting_Output":
		fnComPortSetting();
	break;
	case "Control_Status":
		fnPlayerAction();
	break;
	case "Control_RS232":
		if (!validatePlayersSelected("count")) return false;
		if (validatePlayersSelected("offline") != true) return false;		
		fnRS232Command();
	break;
	case "Control_ExtAction":
		fnExternalCtl();
	break;
	case "Message_Emergency":
		fnEmergencyMsg();
	break;
	case "Message_Notification":
		fnNotificationMsg();
	break;
	case "Alert_Notification":
		fnAlertNotice();
	break;
	case "Alert_Setting":
		fnAlertSetting();
	break;
	case "Report_Generator":
		fnLogGenerator();
	break;
	case "Report_Setting": //-> Alert Notification
		//fnLogSetting();
		CMSShowAlertSetting();
	break;
	case "Health_Service":
		fnCMSService();
	break;
	case "Health_System":
		fnCMSHardwareInfo();
	break;
	case "CMSConf_Time":
		fnCMSTimeSetting();
		
	break;
	case "CMSConf_Network":
		fnCMSNetwork();
	break;
	case "CMSConf_ACL":
		fnAccessControl();
	break;
	case "CMSConf_License":
		fnLicenseSetting();
	break;
	case "CMSConf_Alert":
		fnCMSAlertSetting();
	break;
	case "CMSConf_ExtServer":
		fnExtServer();
	break;
	case "Publish_Properties":
		fnCMSSchedule();
		break;
	case "Publish_Dispatch":
		fnCMSDispatch();
		break;
	case "Publish_ExportImport":
		fnPublishExportImport();
		break;
	case "CMS_Control":
		fnCMSControl();
		break;
	case "CMSConf_Profile":
		fnCMSProfile();
		break;
	case "Control_Schedule":
		if (!validatePlayersSelected("count")) return false;
		if (validatePlayersSelected("offline") != true) return false;
		fnPlayerScheduleControl();
		break;
	case "Player_LogFilter":
		fnPlayerLogFilter();
		break;
	case "Setting_GPS":
		fnGPS();
	break;
	}
}

// CMS Schedule Import HTML5
// 選擇要上傳的schedule時
function scheduleUploaSelectFileChange() {

	// 取得檔案
    var fileObj = document.getElementById('scheduleUploaFileInput').files[0];

    modalWindow('enable');

    var newform = new FormData();

    newform.append("Filedata", fileObj, fileObj.name);

    newform.append("Filename", fileObj.name);

    newform.append("fileext", '*.schl;');

    newform.append("folder", '/upload');

    newform.append("Upload", 'Submit Query');

    $.ajax({
        async: true,
        type: "post",
        dataType: "html",
        url: "uploadify.php",
        data: newform,
        enctype: 'multipart/form-data',
        processData: false,
        contentType: false,
        success: function(fileName){
            // 上傳完成
            scheduleUploaOnComplete(fileName);
        },
        error: function() {
            console.log('Ajax Error');
            modalWindow('disable');
        }
    });
}

// 上傳schedule完成
function scheduleUploaOnComplete(fileName) {

	$.post('main_Schedule.php',{'opt':'importJSON','filename':fileName,'IP':'127.0.0.1'}, function(data){

        modalWindow('disable');

        if (data != 0){
            $().toastmessage('showSuccessToast',g_json.Dispatch_Success);

            //Refresh Table
            InitialCalendar();
            GetScheduleList("0");
            GetPrsnList("0");

        } else {
            $().toastmessage('showErrorToast',g_json.Actions_Failed);
        }
    });
}

/** Import Function **/

function importSchedule(){
}

function importProfile(){
	
	$('#import_profile').uploadify({
		'uploader':	'css/uploadify.swf',
		'script': 'uploadify.php',
		'method': 'post',
		'width': 28,
		'height': 28,
		'multi': false,
		'folder': 'upload',
		'hideButton': false,
		'cancelImg': '',
		'buttonImg': '/images/import_icon.png',
		'wmode': 'transparent',
		'fileExt': '*.tar;',
		'fileDesc': 'Profile',
		'auto': true,
		'onProgress': function(event, ID, fileObj, data){
			
				//Disable Button & Enable Modal Window
				modalWindow('enable');
			
			},
		'onComplete': function(event, ID, fileObj, response, data) {
			$.post('cms_BasicInfo.php',{'opt':'profileImport','filename':fileObj.name},
				function(data){
					modalWindow('disable');
					$().toastmessage('showNoticeToast',g_json.Actions_RestartSystem+" ......"); 				
					$("#Main_Logout").trigger("click");
					
					var json = $.parseJSON(data);
					
					var time = $.parseJSON(json.Time);
					var network = $.parseJSON(json.Network);
					
					
					
					if (display.result && time.result && network.result){
					//if (display.result && time.result){
						$().toastmessage('showNoticeToast',g_json.MSG_0097);
						//$().toastmessage('showSuccessToast',g_json.Dispatch_Success);
					
					} else {
						
						var result = '';
						
						if (!time.result) result += "Time Setting Failed.<br />";
						if (!network.result) result += "Network Setting Failed.<br />";
						
						$().toastmessage('showErrorToast',g_json.Actions_Failed+'<br />'+result);
					}
				});
		},
		'onError':	function(event, ID, fileObj, errorObj){
				$().toastmessage('showErrorToast',"Failed to import.<br />Reason:<br />"+errorObj.info);
			
		}
	});
	if (g_level != 1) {
		$("#import_profile").uploadify('disable',true);
	}
}

// CMS Firmware Update Import HTML5
// 選擇要上傳的firmware時
function firmwareUpdateSelectFileChange(type) {

	// 取得檔案
	if (type == 'cms') {
		var fileObj = document.getElementById('cmsFirmwareUpdateInput').files[0];
	} else {
		var fileObj = document.getElementById('firmwareUpdateInput').files[0];
	}

	modalWindow('enable');

	var newform = new FormData();

	newform.append("Filedata", fileObj, fileObj.name);

    newform.append("Filename", fileObj.name);

    newform.append("fileext", '*.tar.bz2;');

	newform.append("folder", '/download');

    newform.append("Upload", 'Submit Query');

	$.ajax({
		async: true,
        type: "post",
        dataType: "html",
        url: "uploadify.php",
        data: newform,
        enctype: 'multipart/form-data',
        processData: false,
    	contentType: false,
        success: function(fileName){
            // 上傳完成
            firmwareUpdateOnComplete(fileName, type);
        },
        error: function() {
            console.log('Ajax Error');
            modalWindow('disable');
        }
    });
}

// 上傳firmware後
function firmwareUpdateOnComplete(fileName, type) {

	$("#szFWUpadte_textarea").html('');

    if (type == 'player') {
        var playerip = new Array();
        var playerid = new Array();
        var playerversion = new Array();

        $('#stable input[name=players]:checked').each(function() {
            playerip.push($(this).attr('ip'));
            playerid.push($(this).val());
        });

        $.post('main_PlayerSetting.php',{   'opt': 'LocalUpdateInfo', 
                            'filename': fileName,
                            'playerid': playerid}, function(data){

            modalWindow('disable');
            $('#szFWUpdate_SelectVersion').html('');
            var json = $.parseJSON(data);

            var update_versions = json.update_versions;
            var version = json.version;
            if (json.result) {
                $("#szFWUpdate_SelectVersion").unbind('change');
                $('#szFWUpdate_SelectVersion').append($("<option></option>")
                                .attr("value", fileName)
                                .attr("selected", true)
                                .text(json.version));
                $("#szFWUpadte_textarea").html(json.comment);
                $("#szFWUpadte_CheckUpdate").unbind('click');
                $("#szFWUpadte_CheckUpdate").click(function() {
                    if (g_level != 1) return false;
                    PlayerUpdate(json.version, fileName, json.update_versions);
                });
            } else {
                $("#szFWUpadte_textarea").html('');
            }
        });
    } else {
        $.post('cms_BasicInfo.php',{    'opt': 'LocalUpdateInfo', 
                        'filename': fileName}, function(data){
            modalWindow('disable');
            $('#szCMSLicense_SelectVersion').html('');

            var json = $.parseJSON(data);
            if (json.result) {
                $("#szCMSLicense_SelectVersion").unbind('change');
                $('#szCMSLicense_SelectVersion').append($("<option></option>")
                                .attr("value", fileName)
                                .attr("selected", true)
                                .text(json.version));
                $("#szCMSLicense_textarea").html(json.comment);

                $("#License_CheckUpdate").unbind('click');
                $("#License_CheckUpdate").click(function() {

                    modalWindow('enable');
                    g_DispatchActive = true; //Temporary use

                    $.post('cms_BasicInfo.php',{'opt': 'UpdateFirmware', 
                                    'file': $("#szCMSLicense_SelectVersion").val(),
                                    'mode': 'local'}, function(data) {
                        g_DispatchActive = false; //Temporary use
                        modalWindow('disable');

                        var json = $.parseJSON(data);

                        if (json.result){

                            $().toastmessage('showNoticeToast',"Firmware Update Result: <br />" + g_json.FWUpdate_Updated_Success);
                            ('#Main_Logout').click();

                        } else {
                            $().toastmessage('showNoticeToast',"Firmware Update Result: <br />" + g_json.FWUpdate_Updated_Failed);
                        }
                    });
                });
            } else {
                var sReason = (json.type == 'version')? 'Not Available Version!' : 'Error File Type!';
                $().toastmessage('showErrorToast',"The file you selected is for "+type+" firmware update.<br />Please select a correct file.");
                $("#szCMSLicense_textarea").html('Error occurred, reason: <br />'+sReason);
            }
        });
    }
}

function importUpdate(type){
	if (g_level != 1) {
		$("#szFWUpadte_CheckUpdate").removeClass('btn1').addClass('btn1_dis');
	} else {
		$('#firmwareUpdateBtn').show();
		$('#cmsFirmwareUpdateBtn').show();
	}
}

function PlayerUpdate(version, file, update_versions) {

	modalWindow('enable');
	g_DispatchActive = true; //Temporary use

	var playerip = new Array();
	var playerid = new Array();
	var playerversion = new Array();
	var firmwareUpdateResult = '';

	$('#stable input[name=players]:checked').each(function() {
		playerip.push($(this).attr('ip'));
		playerid.push($(this).val());
	});

	$.post('main_PlayerSetting.php',{'opt':'GetCheckedFirmwareVersion','playerids': playerid},function(data) {
		var json = $.parseJSON(data);

		for (var i=0;i<json.length;i++) {
			var index = playerid.indexOf(json[i]['PlayerID']);
			if (index != -1){
				playerversion[index] = json[i]['Version'];
				if (update_versions.indexOf(json[i]['Version']) == -1) {
					PlayerFirmwareUpdateComplete(g_json.FWUpdate_Updated_Failed);
					return;
				}
			}
		}

		index = 0;
		for (var i=0;i<playerid.length;i++) {

			if (playerversion[i] == version) {
				index++;
;
				firmwareUpdateResult += playerip[i] + ': ' + g_json.FWUpdate_Latest_Version + '<br />';

				if (index == playerid.length) {
					PlayerFirmwareUpdateComplete(firmwareUpdateResult);
				}
			} else {
				$.post('main_PlayerSetting.php',{'opt':'UpdateFirmware',
											'IP':playerip[i],
											'iEcho':i,
											'server':'cms',
											'file':file,
											'mode':'update'}, function(data) {
					var json = $.parseJSON(data);
					index++;

					if (json.result == true){
						firmwareUpdateResult += playerip[json.iEcho] + ': ' + g_json.FWUpdate_Updated_Success + '<br />';
					} else {
						firmwareUpdateResult += playerip[json.iEcho] + ': ' + g_json.FWUpdate_Updated_Failed + '<br />';
					}

					if (index == playerid.length) {
						PlayerFirmwareUpdateComplete(firmwareUpdateResult);
					}
				});
			}
		}
	});
}

function PlayerFirmwareUpdateComplete(UpdateResult) {
	g_DispatchActive = false; //Temporary use
	modalWindow('disable'); 

	$().toastmessage('showNoticeToast',"Firmware Update Result: <br />" + UpdateResult);
}

/*** modalWindow ***/

function modalWindow(status,msg){ 
	
	//Localization
	$('#modal_textarea_text').html('<img src="./images/loading.gif" />'+ g_json.Table_Processing);
	
	switch(status){
		case 'enable':
			
			g_modal = true;
			
			$('#modal_window').show();
			$('#modal_window_bg').show();
			
			//Latency process (Default: 10 sec)
			setTimeout("modalWindowLatency()",10000);
			
			break;
		
		case 'disable':
			
			g_modal = false;
			
			$('#modal_window').hide();
			$('#modal_window_bg').hide();
			$('#modal_textarea_detail_btn').hide();
			$('#modal_textarea_cancel_btn').hide();
			$('#modal_textarea_detail').hide();
			$('#modal_textarea_detail').html("");
			
			break;				
		
		case 'append':
			
			$('#modal_textarea_detail').append(msg+"<br />");
			
			break;
		
	}	
}

function modalWindowLatency(){
	
	//Close Button
	$('#modal_textarea_cancel_btn').unbind('click');
	$('#modal_textarea_cancel_btn').click(function(){
		
		$('#modal_window').hide();
		$('#modal_window_bg').hide();
		$('#modal_textarea_detail_btn').hide();
		$('#modal_textarea_cancel_btn').hide();
		$('#modal_textarea_detail').html("");
		
		return false;
	});
	
	//Detail Button
	$('#modal_textarea_detail_btn').unbind('toggle');
	$('#modal_textarea_detail_btn').toggle(function(){
		$('#modal_textarea_detail').show();
	}, function(){
		$('#modal_textarea_detail').hide();
	});
	
	if (g_modal == true) {
		$('#modal_textarea_detail_btn').show();
		$('#modal_textarea_cancel_btn').show();
	}
}

/*** These function can be removed ***/
function isHide(ver){var iVer = ver||1.3;return (g_ver < iVer)? true: false;}
function RemoveFunc(id){
var fun_1_3_0 = ['hidden_shutdownbtn','hidden_wol','hide_ScResume','hide_ScPause','hidden_NTP'];
var fun_deprecated = ['Report_Setting','Alert_Notification'];
if (id){$('#'+id).remove();}
if (g_ver < 1.3) {for (var i = 0; i < fun_1_3_0.length; i++){$('#'+fun_1_3_0[i]).remove();}}
else {for (var i = 0; i < fun_deprecated.length; i++){$('#'+fun_deprecated[i]).remove();}}
}

/*** document.ready() ***/

$(document).ready(function() {
	$('#initWindow').show(); //End-> in special func
	
	Authentication();
	
	setInterval(function() {  
		Authentication();
	}, 7500*1000);	
	
	/*
	setInterval(function() {	//Refresh Player List
		InitMainTable(g_json);	
	}, 60*1000);	
	*/

	//fnPublishExportImport() in main_Schedule.js
	//Due to not support 'destroy'
	/*
	importSchedule();
	importProfile();
	importUpdate('cms');
	importUpdate('player');
	*/
	setTimeout(function(){
		importUpdate('player');
		importUpdate('cms');
		importProfile();
		importSchedule();
	},1000);

	RemoveFunc();
	//$(window) event in InitWindowEvents()
	//PublishDispatchFailedRecordsStartup in special function
	
});

